# Modules
Modules control the core feature set of catBot, allowing a quick and easy way to bring in or out features without effecting others. Each feature set should be isolated into a single python file within this directory, after which the main script can load it as long as it ends in a .py extension, and does not start with a ".". This will be a drag and drop option for those who just wish to run a catBot for their server, but details on developing your own module is below. If you do develop the module, don't forget it's manual!

## Module Format
Each module file that fits the description above is loaded by the mainscript, and its "\_start\_up(name, conf_path, data_path)" function run. The start up function does not return anything, and just allows for global variables in the module to update in order to correctly store config and data files. Other functions in the file are detailed below, using the following patterns:

General Commands are single-word functions that always return a string. They can be called by users using the "[PREFIX][COMMAND]   [EXTENTION]   [FUNCTION]" syntax in Discord. All General Commands must be only made of letters or numbers, and are passed a list of sanatized arguements from the user's message as a first positional arguement, and the full message data that contained the command in the second. Using the arguements list is generally preferred unless the command requires the use of special characters.

Bind Only Commands are functions containing underscores, which make them uncallable via Discord messaages in the traditional way. These instead act as functions to call via Overrides, which are explained lower down.

Internal Only Commands are just normal functions, but it is suggested to put a "\_" before them (like "\_save\_conifg"). This is just for making it easier to keep track of what is being called by the users and what is being called by program alone.

### Overrides
Each Command Extension needs to have a "\_command\_override()" and a "\_reaction\_override()" function, which I would recommend putting at the top. These functions must return a dictionary of values the Command Extension is meant to handle outside of the normal command structure.

\_command\_override() dictionary keys must be an exact string a user must type, and acts as a shortcut to another command listed in the file. For example, the verification Command Extension shortcuts the access message to the \<PREFIX\>verification confirm \<access message\> so users don't have to type the whole command beforehand. These commands must still accept the same arguements as General Commands, but the sanatized arguements will always be an empty list. These can be in the end, thought of as quick shortcuts that dont require the prefix to activate. Command overrides support Bind Only Commands as well, since they shortcut sanatization due to being hard coded by developers.

\_reaction\_override() is similar to command overrides, but allows Commandd Extensions to use reactions, since the bot alone does not use them. Dictionaries here should have their keys be unicode or custom emojis instead of a specific phrase, and when that reaction is detected by the bot, it will run the function (formatted as its name in a string) attached to that key. Functions called by the results of a \_reaction\_override() will always be given 3 arguements, one for if it was an add or remove call, one for the raw reaction data, and one pass through of the client for making potential fetch requests.